module OpdrachtEIND where
import List
--                -        

------------------------------------------------------------------------------------------------------------------------
--        
------------------------------------------------------------------------------------------------------------------------
{-
                  
           
     "        "  "                    " 
     "      "  "                    " 
     "   "  "                  " 
     "   "  "                  " 
     "    "  "                  " 
     "        "  "   " 
     "         "  "                         " 
     "         "  "                                 " 
     "   "  "                                 " 
   

                 
          
     "                    "  "    "  "    " 
     "                    "  "         "  "       " 
     "                  "  "        "  "    " 
     "                  "  "        "  "         " 
     "                  "  "                "  "         " 
     "                         "  "                "  "         " 
     "                                 "  "      "  "        " 
   

              
       
     "                    "  "     " 
     "                    "  "            " 
     "                  "  "            " 
     "                  "  "       " 
     "                  "  "       " 
     "                         "  "            " 
     "                                 "  "            " 
   

              
       
             "        " 
              "     "           "            " 
                                               


-}

------------------------------------------------------------------------------------------------------------------------
--                  
------------------------------------------------------------------------------------------------------------------------
type Table = [[String]]


------------------------------------------------------------------------------------------------------------------------
--       ----                        
------------------------------------------------------------------------------------------------------------------------
--               
writeTable :: Table -> String
writeTable []       = ""
writeTable tabel    = str ++ schrijfRegel widths (head tabel) ++ str ++ schrijfRegels widths (tail tabel)++ str
                where str = scheidingsRegel(breedteKolom tabel)
                      widths = breedteKolom tabel

--                      
{-
                         -        
                             " "                   -                       
                             "   "
  -}
scheidingsRegel :: [Int] -> String
scheidingsRegel widths = " " ++ concatMap (\k -> replicate k '-' ++ " ") widths ++ "  "

--                     
schrijfRegels   :: [Int]->Table -> String
schrijfRegels widths tabel       = concatMap (schrijfRegel widths) tabel

--                 
schrijfRegel    :: [Int] -> [String] -> String
schrijfRegel ns xs  = concatMap (\(s,i) -> " " ++ s ++ replicate (i - length s) ' ') (zip xs ns)  ++ "   "

{-
                                    -           -        
                             "   "
                             " "                            -                                           
-}

--                                                                            
breedteKolom               :: Table -> [Int]
breedteKolom tabel         = map bepaalLangsteWoord (transpose tabel)

--                                     
bepaalLangsteWoord :: [String] -> Int
bepaalLangsteWoord xs = maximum (map length xs)

{-
------------------------------------------------------------------------------------------------------------------------
--       ----                        
------------------------------------------------------------------------------------------------------------------------
--                                            
                    -        -       
                                      

--                                      
                           -        -       
                                  
                                                                                                   
                                                                                                
                                                                      
-}
--                                                 
controlePerWoord :: String -> Table -> [String]
controlePerWoord _ []           = []
controlePerWoord x (y:ys)       | eqString x (head y) = y
                                | otherwise           = controlePerWoord x ys



------------------------------------------------------------------------------------------------------------------------
--       ----                       
------------------------------------------------------------------------------------------------------------------------

--                                                        
select :: String -> (String -> Bool) -> Table -> Table
select veld conditie tabel =  head tabel:selecteerRijen (nummerKolom veld tabel) (filter conditie (drop 1 k)) tabel
       where k = controlePerWoord veld  (transpose tabel )

selecteerRijen :: Int -> [String] -> Table -> Table
selecteerRijen _ []           _                             = []
selecteerRijen _ _            []                            = []
selecteerRijen n lijst@(y:ys) (x:xs) | eqString y (x !! n)  = x :  selecteerRijen ys xs
                                     | otherwise            = selecteerRijen lijst xs

nummerKolom :: String -> Table -> Int
nummerKolom s t = snd (vindTupel s (zip (head t) [0..]))
            where vindTupel st l = head (filter (\(x,_) -> not(eqString st x) ) l)


------------------------------------------------------------------------------------------------------------------------
--       ----                        
------------------------------------------------------------------------------------------------------------------------
{-

              -        -       
                                                                            
                                                        -             -                            
                                                                                     
                                                                                            
                                                                                            
                                                                             
                                                                         
                                                                                     
                                                                                "                             "
                                                                  
                                                                                                          
                                                                           -                 -                              

--                                             
                    -           -     
                               "                             "
                                                    
                                                                         

-}
{-
            
            

   

                       

-}

{-
--                                                                                                                                    
                     -          
                    
                                                 

--                                     
                         -          
                                     "" 

--                                                                 
                   -           -        
                           ""
                                                                            
                                                                     
-}
{-
------------------------------------------------------------------------------------------------------------------------
--      ----                              
------------------------------------------------------------------------------------------------------------------------
                  -        -       
                     
                
                -               
                                                                         

                          -              -          
                                      

                    -        -          
                                                          

                     -        -          
                    
                                                       --          
                                                                       

                  -           -      
                  
                  
                  
                   

                   -         -      
                                         



------------------------------------------------------------------------------------------------------------------------
--      ----                 
------------------------------------------------------------------------------------------------------------------------
                       -        -       
                                                                                
                                                                        "                                                                         "

 ------------------------------------------------------------------------------------------------------------------------
--      ----                   
------------------------------------------------------------------------------------------------------------------------
                         -        -       
                                                                                                                       
                                                                                        "                                                                     "
-}


