data Prop

   = En [Prop]     --                
   | Of [Prop]     --                
   | Niet Prop
   | Prop :-> Prop --                  
   | Var String    --          
   | Bool Bool     --           

type Bedeling = [String]

evalueer :: Prop -> Bedeling -> Bool
evalueer (En props)    bedeling = all (\prop -> evalueer prop bedeling) props
evalueer (Of props)    bedeling = any (\prop -> evalueer prop bedeling) props
evalueer (Niet prop)   bedeling = not (evalueer prop bedeling)
evalueer (Var string)  bedeling = or  (map (eqString string) bedeling)
evalueer (Bool bool)   _        = bool

vervulbaar :: Prop -> [Bedeling]
vervulbaar (propsA :-> propsB) = propsA : propsB :[]


