module Statistics.DescriptiveAnalysis.KeyMaybeAImpl where

import Statistics.DescriptiveAnalysis.KeyableAC (
                                                                Keyable
                                                              , startkey
                                                              , combine
                                                          )

instance (Keyable a) => Keyable (Maybe a) where
   startkey = Nothing
   combine Nothing newkey = newkey
   combine (Just x) newkey = 
      case newkey of
         Nothing   ->  Just x
         Just key  ->  Just (x `combine` key)