module Statistics.Presentation (
     module Statistics.Presentation
   , module Statistics.Presentation.RepresentationActions
   , module Statistics.Presentation.TextRepresentation
   , module Statistics.Presentation.MarkUpDoc
   , module Statistics.Presentation.Ploticus
   ) where

-- for presenting data in for instance gnuplot and sort like tools

import Statistics.Presentation.TextRepresentation
import Statistics.Presentation.RepresentationActions
import Statistics.Presentation.MarkUpDoc hiding (header, title)
import qualified Statistics.Presentation.MarkUpDoc
import Statistics.Presentation.Ploticus hiding (newline, tab)
