module Thesis.HeliumUniversal.ImportError where

import Data.Typeable
import Thesis.HeliumUniversal.BasicTypes

----------------------------------------------------------------------------------------
-- Resolve Error , similar for all helium version up to 1.5.1
----------------------------------------------------------------------------------------


-- ResolveError is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5v1/Src/HeliumNT/Src/Parser/ResolveOperators.hs:14
data ResolveError = Ambiguous Assoc Name Assoc Name
     deriving (Show, Read, Eq, Typeable)
    
-- Assoc is a type constructor, defined at /users/pkeeken/trunk/development/instrumented_helium_compilers/Helium1v5v1/Src/HeliumNT/Src/Parser/OperatorTable.hs:22
data Assoc = AssocNone | AssocLeft | AssocRight
    deriving (Show, Read, Eq, Typeable)

-- moved to HeliumBasicTypes
-- data Name
-- data Range
-- data Position
-- type Strings = [String]
    
{-
:i ResolveError
:i Assoc
:i Name
:i Range
:i Strings
:i Position

-}
