module Thesis.HeliumUniversal.LexerToken.Helium1v1_Helium1v1v1LexerToken where

-----------------------------------------------------------
-- Constants
-----------------------------------------------------------

escapeChars :: String
escapeChars = "\\nabfnrtv\"'"

symbols :: String
symbols = "!#$%&*+./<=>?@^|-~:\\"

keywords :: [String]
keywords = 
    [ "let", "in", "do", "where", "case", "of", "if"
    , "then", "else", "data", "type", "module", "import"
    , "infix", "infixl", "infixr", "_"
    , "class", "instance", "default", "deriving", "newtype" -- not supported
    , "phase", "constraints" -- Bastiaan
    ]

reservedConSyms :: [String]
reservedConSyms =
    [ "::"
    , ":" -- Bastiaan
    ]

reservedVarSyms :: [String]
reservedVarSyms =
    [ "=>", "->", "<-", "..", "-", "-.", "@", "=", "\\", "|"
    , "==" -- Bastiaan
    ]

specialsWithoutBrackets :: String
specialsWithoutBrackets = 
    ",`;" 
