module Thesis.MainI where

import Statistics.DescriptiveAnalysis
import Statistics.Presentation

-- for ana impl
import Thesis.AnalysisPredefined
import Thesis.Helium.Logging

--------------------------------------
-- Analysis Tool Interpreter
--------------------------------------

-- Load this file for running of predefined researches

{-

-- Template for analysing helium logging data:

dflt_logfile = "/scratch/data/fp/archives/helium0203/fp0203_recompilation_onlyCompilesTst100.log"
dflt_outputpath = "/users/pkeeken/scratch/tmp/analyses_output/researchOutput/"

testRunResearch :: (Keyable key) => ([Logging] -> key -> FilePath -> IO ()) -> IO ()
testRunResearch research = runResearchFromLogFileKeyable research dflt_logfile dflt_outputpath

main = testRunResearch <own research or research from predef research set>


<own research> logs key outputpath =
   do
      let
         runAna = runAnalysisGeneric logs key
         ana = <anacombinator> "FP 0203"
      
      putStrLn $ showAsTextTable $ runAna ana

-}