--         

data Prop
  = En [Prop]     --                
  | Of [Prop]     --                
  | Niet Prop
  | Prop :-> Prop --                  
  | Var String    --          
  | Bool Bool     --           

type Bedeling = [String]

evalueer :: Prop -> Bedeling -> Bool
evalueer (En props)        lijst     = all (\prop -> evalueer prop lijst) props    --                                                                                                                        
evalueer (Of props)        lijst     = any (\prop -> evalueer prop lijst) props
evalueer (Niet prop)       lijst     = not (evalueer prop lijst)
evalueer (prop1 :-> prop2) lijst
        | evalueer prop1 lijst
          &&
          not (evalueer prop2 lijst) = False
        | otherwise                  = True
evalueer (Var s)           lijst     = elemBy eqString s lijst
evalueer (Bool b)          lijst     = b

--               -   
--                         
--          
--          
--   

--                   -            
--                                
--                                
--                                
--                   -            
--                                
--                                

--                                             
geefVariabelen :: Prop -> [String]
geefVariabelen (En props)          = concatMap (\prop -> geefVariabelen prop) props
geefVariabelen (Of props)          = concatMap (\prop -> geefVariabelen prop) props
geefVariabelen (Niet prop)         = geefVariabelen (prop)
geefVariabelen (prop1 :-> prop2)   = geefVariabelen (prop1)++geefVariabelen (prop2)
geefVariabelen (Var s)             = [s]
geefVariabelen (Bool b)            = []


--                   -      
--                                        
--                                        
--                                        
--                   -                    
--                                        
--                                        

--                     -      
--                                          
--                                          
--                                          
--                     -                    
--                                          
--                                          

--             -        
--                                  
--                                  
--                                  
--             -                    
--                                  
--                                  

--                   -       -      
--                                        
--                                        
--                                        
--                   -                    
--                                        
--                                        


--                 -      
--                                      
--                                      
--                                      
--                 -                    
--                                      
--                                       

--                  -      





