import List

type Table = [[String]]
compilers :: Table

compilers =
  [["        ", "                    "]
  ,["      ", "                    "]
  ,["   ", "                  "]
  ,["   ", "                  "]
  ,["    ", "                  "]
  ,["        ", "                  "]
  ,["         ", "                         "]
  ,["         ", "                                 "]
  ,["   ", "                                "]
  ]

locaties :: Table

locaties =
  [["                  ", "    ", "    "]
  ,["                    ", "         ", "       "]
  ,["                  ", "        ", "    "]
  ,["                  ", "        ", "         "]
  ,["                  ", "                ", "        "]
  ,["                         ", "                ", "         "]
  ,["                                 ", "      ", "         "]
  ]



pakString :: [String] -> Int -> String
pakString [] _ = ""
pakString x t | length x > t = x !! t
              | otherwise = "  "

pakInt :: [Int] -> Int -> Int
pakInt [] _ = -1
pakInt x  t | length x > t = x !! t
            | otherwise = 0
        
remHead :: [Int] -> [Int]
remHead [] = []
remHead (_:xs) = xs

lengteInLijst :: [String] -> [Int]
lengteInLijst [] = []
lengteInLijst (x:xs) = (length x) : (lengteInLijst xs)

lengteInLijstInLijst:: [[String]] -> [[Int]]
lengteInLijstInLijst [] = []
lengteInLijstInLijst [[]] = [[]]
lengteInLijstInLijst (x:xs) = lengteInLijst x : lengteInLijstInLijst xs

maxPerKolom :: [[Int]] -> Int -> [Int]
maxPerKolom [] _ = []
maxPerKolom (x:xs) kolomNr | (kolomNr < (length x)) = ((x !! kolomNr) : (maxPerKolom xs kolomNr))
                           | otherwise = []

maxLengte :: [[String]] -> Int -> [Int]
maxLengte x kolomNr
    | kolomNr < length (head x) = (maximum (maxPerKolom (lengteInLijstInLijst x) kolomNr)) : (maxLengte x (kolomNr+1))
    | otherwise                 = []

lengte :: String -> Int -> String
lengte x ma | (length x) /= ma = lengte (x ++ " " ) ma
            | otherwise = x

project :: [String] -> Table -> Table
project columns table = transpose (filter (\column-> elemBy eqString (head column) columns) (transpose table))

--                  -          -        -        -       
--                                                                                                



nummerKolom :: String -> [String] -> Int -> Int
nummerKolom "" _ _ = 0
nummerKolom _ [] _ = 0
nummerKolom x (y:ys) a | not(eqString x y) = nummerKolom x ys (a+1)
                       | otherwise = a

writeTable :: Table -> String
writeTable table = writeTable' table
    where writeTable' []     = ""
          writeTable' [[]]   = ""
          writeTable' (x:xs) = "  " ++ lengte (pakString x 0) (maxi !! 0) ++ "   "++ lengte (pakString x 1) (maxi !! 1) ++ "    " ++ writeTable' xs
          maxi = maxLengte table 0


