type Table = [[String]]

compilers :: Table
compilers =
  [ ["        ", "                    "]
  , ["      ", "                    "]
  , ["   ", "                  "]
  , ["   ", "                  "]
  , ["    ", "                  "]
  , ["        ", "                  "]
  , ["         ", "                         "]
  , ["         ", "                                 "]
  , ["   ", "                                 "]
  ]

locaties :: Table
locaties =
  [ ["                    ", "    ", "    "]
  , ["                    ", "         ", "       "]
  , ["                  ", "        ", "    "]
  , ["                  ", "        ", "         "]
  , ["                  ", "                ", "         "]
  , ["                         ", "                ", "         "]
  , ["                                 ", "      ", "        "]
  ]

writeTable :: Table -> String
writeTable [] = []
writeTable (x:xs) = concat
                    [lijn (x:xs),
                    "   "
                    ,namenHorizontaal x
                    ,"  "
                    --            
                    ,veldNamen xs]
                    --        

--                 -       -      -       
--                      
--                                                          
{-                                                                                                                 -}

--                  -       -      -       
wordLength [] = []
wordLength (x:xs) = length (head x) : wordLength xs

highest :: [Int] -> Int
highest xs = last (insertionSort xs)

transpose (xs:xss) = zipWith (:) xs (transpose xss)
transpose [] = repeat []

--                   -       -      -     
--                                                 

--                    -       -      -     
breedteKolom xs = highest (wordLength xs)

lengtes (x:xs) = wordLength(transpose (x:xs))

--                 -        
lijn [] = []
lijn (x:xs) = concat
              [(replicate (breedteKolom (x:xs)) '-')
              ," "
              ,lijn xs]

veldNamen :: [[String]] -> [Char]
veldNamen [] = []
veldNamen (x:xs) = concat
                   [" "
                   ,namenHorizontaal x
                   ,"  "
                   ,veldNamen xs]

namenHorizontaal :: [String] -> [Char]
namenHorizontaal [] = []
namenHorizontaal (x:xs) = concat
                          [x
                          ,(replicate 3 ' ')
                          ," "
                          ,namenHorizontaal xs]

--               -       -      -     
--                                       -                       

--                     -     
verschil xs = (breedteKolom xs)-head(wordLength xs)

second :: [a] -> a
second (_:x:_) = x

voegIn :: Int -> [Int] -> [Int]
voegIn x [] = [x]
voegIn y (z:zs) | y < z = y : z:zs
                | otherwise = z:voegIn y zs

insertionSort :: [Int] -> [Int]
insertionSort [] = []
insertionSort (x:xs) = voegIn x (insertionSort xs)




