module Thesis.Helium.HeliumInfo where

import Thesis.Helium.Logging

-- information regarding the different compilers

helium1v0   = HeliumVersion "1.0"   ""
helium1v1   = HeliumVersion "1.1"   "Mon-Mar-10-09_19_12--2003"
helium1v1A  = HeliumVersion "1.1A"  ""
helium1v1v1 = HeliumVersion "1.1.1" ""
helium1v1v2 = HeliumVersion "1.1.2" ""
helium1v2   = HeliumVersion "1.2"   ""
helium1v2v1 = HeliumVersion "1.2.1" ""
helium1v2v2 = HeliumVersion "1v2.2" ""
helium1v5   = HeliumVersion "1.5"   ""
helium1v5v1 = HeliumVersion "1.5.1" ""

heliums :: [HeliumVersion]
heliums = [ helium1v0, helium1v1, helium1v1A, helium1v1v1 {- etc -}
 ]